poj 2431 Expedition(优先队列+贪心)(北邮新生赛2016H)

来源:互联网 发布:win7电脑优化软件 编辑:程序博客网 时间:2024/04/29 19:31

Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 10700 Accepted: 3117

Description

A group of cows grabbed a truck and ventured on an expedition deep into the jungle. Being rather poor drivers, the cows unfortunately managed to run over a rock and puncture the truck's fuel tank. The truck now leaks one unit of fuel every unit of distance it travels. 

To repair the truck, the cows need to drive to the nearest town (no more than 1,000,000 units distant) down a long, winding road. On this road, between the town and the current location of the truck, there are N (1 <= N <= 10,000) fuel stops where the cows can stop to acquire additional fuel (1..100 units at each stop). 

The jungle is a dangerous place for humans and is especially dangerous for cows. Therefore, the cows want to make the minimum possible number of stops for fuel on the way to the town. Fortunately, the capacity of the fuel tank on their truck is so large that there is effectively no limit to the amount of fuel it can hold. The truck is currently L units away from the town and has P units of fuel (1 <= P <= 1,000,000). 

Determine the minimum number of stops needed to reach the town, or if the cows cannot reach the town at all. 

Input

* Line 1: A single integer, N 

* Lines 2..N+1: Each line contains two space-separated integers describing a fuel stop: The first integer is the distance from the town to the stop; the second is the amount of fuel available at that stop. 

* Line N+2: Two space-separated integers, L and P

Output

* Line 1: A single integer giving the minimum number of fuel stops necessary to reach the town. If it is not possible to reach the town, output -1.

Sample Input

44 45 211 515 1025 10

Sample Output

2

Hint

INPUT DETAILS: 

The truck is 25 units away from the town; the truck has 10 units of fuel. Along the road, there are 4 fuel stops at distances 4, 5, 11, and 15 from the town (so these are initially at distances 21, 20, 14, and 10 from the truck). These fuel stops can supply up to 4, 2, 5, and 10 units of fuel, respectively. 

OUTPUT DETAILS: 

Drive 10 units, stop to acquire 10 more units of fuel, drive 4 more units, stop to acquire 5 more units of fuel, then drive to the town.

Source

USACO 2005 U S Open Gold

题目大意:

         最初有P升油的一辆车从起点出发,途径一些加油站,每一个加油站都有离终点的距离和可以加的油量。给定起点与终点的距离L,还有最初的油量P,求最少在多少个加油站加油可以走到终点,没有方案输出-1

解题思路:

       这道题我开始想的是一个01背包,dp[i][j]表示经过第i个加油站后油量>=j的最小加油次数,但是数据是1e6个加油站,dp的时间复杂度太高。

       后来又玩命想,想到了图论中一道叫做watermelon的一道题,每一个加油站能覆盖哪个加油站就向哪个加油站连一条1的边求最短路。但是这道题不是到一个站之前的油就废了,和watermelon题意不同,所以也不能用图论。

  那怎么办呢,看数据是一个nlogn的题。什么是nlogn的?排序是,排序和贪心又经常一起用,所以我绕了一会想到了贪心。

 自己想了一些贪心策略,先想找全局最大的加,有反例否了,后来想找走完p之后再加p之前的最大的那个,没想到堆,不完善,最后想到正确思路:

       按加油站距起始位置从小到大排序,当前油量p能到的加油站里选择最大油量的加油站加,加到p>=L为止。选择加油站里最大油量的用优先队列,因为p能走到的加油站里是一定要选至少一个的,要不然走不下去了,那我就选最大,这样方案就可以做了。

ps:2016北邮新生赛H题即为这题

#include<stdio.h>#include<queue>#include<algorithm>using namespace std;struct node{int d,x;}a[1000005];priority_queue<int>q;int cmp(node a,node b){    return a.d>b.d;}int main(){    int n,cnt=0,l,p;    scanf("%d",&n);    for(int i=0;i<n;i++)        scanf("%d%d",&a[i].d,&a[i].x);    sort(a,a+n,cmp);    scanf("%d%d",&l,&p);    int pos=0;    while(p<l)    {        while(pos<n&&l-a[pos].d<=p)        {            q.push(a[pos].x);            pos++;        }        if(q.empty()) {printf("-1\n");return 0;}        p+=q.top();        q.pop();        cnt++;    }    printf("%d\n",cnt);}


0 0